XIncludeFile "./header/pblibav_import.pbi"
XIncludeFile "./header/pblibav_struct.pbi"
XIncludeFile "./header/pblibav_window.pbi"
XIncludeFile "./header/bass.pbi"

InitSprite()


PB_AVInit()

Open_Window_0()

myFile.s = "d:/test.avi"

; Video Datei ffnen
Global *myFile.PBAV_FILE_INFO = PB_AVOpenAVFile(myFile) 


; Direct Sprite Output aktivieren
*myFile\Video\dso =1


; Codec laden
PB_AVLoadStreamCodecs(*myFile)

; Queue Thread starten
th1 = CreateThread(@PB_AVLoadQueue(), *myFile)


CreateSprite(#TestSprite, *myFile\Video\width, *myFile\Video\height, 4)


Procedure WriteStream(handle.l, *buffer,  length, *PBAV.PBAV_FILE_INFO)  
  
  PB_AVGetAudioFrame(*PBAV) 
  CopyMemory(*PBAV\Audio\AVC\Buffer, *buffer, length)  
  
  ProcedureReturn length;
EndProcedure


	BASS_SetConfig(#BASS_CONFIG_UPDATEPERIOD,39);
;	BASS_SetConfig(#BASS_CONFIG_BUFFER, 4096);
		
	
	BASS_Init(BASS_GetDevice(), *myFile\Audio\sample_rate, #BASS_DEVICE_LATENCY|#BASS_DEVICE_CPSPEAKERS ,0,0)
	
	myStream = BASS_StreamCreate(*myFile\Audio\sample_rate, *myFile\Audio\channels, 0, @WriteStream(), *myFile);
	
	BASS_ChannelSetAttribute(myStream, #BASS_ATTRIB_MUSIC_VOL_GLOBAL, 1000)	
	BASS_ChannelPlay(myStream, 0)
		
	
	
	; Video Thread starten
	th2 = CreateThread(@PB_AVGetVideoFrame(), *myFile)
	
	
	
Repeat
  Event = WindowEvent() 
  ClearScreen(RGB(255,255,255))
  
  
;    StartDrawing(SpriteOutput(#TestSprite))
;    CopyMemory(*myFile\Video\AVC\Buffer, DrawingBuffer(), *myFile\Video\AVC\BufferSize)
;    Debug  *myFile\Video\AVC\BufferSize
;    StopDrawing()
  
      PB_AVLockMutex(*myFile\Video\AVC\BufferMutex)   ; WICHTIG !
        DisplaySprite(*myFile\Video\AVC\Buffer, 0, 0) 
        FlipBuffers()
      PB_AVUnlockMutex(*myFile\Video\AVC\BufferMutex) ; WICHTIG !
      
      If Event = #PB_Event_CloseWindow
       *myFile\quit = 1  
       WaitThread(th1)
       WaitThread(th2) 
      EndIf 
  ;Debug *myFile\test
  
  Delay(1)
Until Event = #PB_Event_CloseWindow

PB_AVUnloadStreamCodecs(*myFile)

PB_AVCloseFile(*myFile)

BASS_Free();

; IDE Options = PureBasic 4.60 Beta 3 (Windows - x86)
; CursorPosition = 12
; Folding = -
; EnableXP